<?php

require_once 'pomo/translations.php';
require_once 'pomo/mo.php';

class N2LocalizationAbstract
{

    static $l10n = array();

    static $js = array();

    static function load_textdomain($domain, $mofile) {
        if (!is_readable($mofile)) return false;

        $mo = new MO();
        if (!$mo->import_from_file($mofile)) return false;

        if (isset(self::$l10n[$domain])) $mo->merge_with(self::$l10n[$domain]);
        self::$l10n[$domain] = &$mo;

        return true;
    }

    static function load_plugin_textdomain($path, $domain = 'nextend') {
        if (N2Settings::get('force-english-backend')) {
            $locale = 'en_EN';
        } else {
            $locale = N2Localization::getLocale();
        }
        $mofile = $locale . '.mo';
        if ($loaded = N2Localization::load_textdomain($domain, $path . '/languages/' . $mofile)) {
            return $loaded;
        }
    }

    static function addJS($texts) {
        foreach ((array)$texts AS $text) {
            self::$js[$text] = n2_($text);
        }
    }

    static function toJS() {
        if (count(self::$js)) {
            return 'window.nextend.localization = ' . json_encode(self::$js) . ';';
        }
        return '';
    }
}

N2Loader::import('libraries.localization.localization', 'platform');

N2Localization::load_plugin_textdomain(N2LIBRARY);

function n2_get_translations_for_domain($domain) {
    if (!isset(N2Localization::$l10n[$domain])) {
        N2Localization::$l10n[$domain] = new NOOP_Translations;
    }
    return N2Localization::$l10n[$domain];
}

function n2_($text, $domain = 'nextend') {
    $translations = n2_get_translations_for_domain($domain);
//    print_r($translations);
    $res = $translations->translate($text);
    if ($res==$text){
        $res = '';
        $translateru['Hover'] = 'Наведение';
        $translateru['Accordion Slide Title']= 'Заголовок слайда аккордеона';
        $translateru['List']= 'Список';
        $translateru['Delete and never ask for confirmation again']='Удалить и никогда не спрашивать подтверждения';
        $translateru['Documentation']='Документация';
        $translateru['Split']='Разбивать';
        $translateru['Chars']='Символы';
        $translateru['Words']='Слова';
        $translateru['%sGet your license key here%s or %sbuy a new%s!']='Введите свою лицензию в поле или купите новую';
        $translateru['Saved slide']='Сохраненный слайд';
        $translateru['Version']='Версия';
        $translateru['Import slider']='Импорт слайдера';
        $translateru['Check for updates']='Проверить апдейты';
        $translateru['Deauthorize license']='Сбросить лицензию';
        $translateru['Manual order']='Ручной порядок';
        $translateru['A-Z']='А-Я';
        $translateru['Z-A']='Я-А';
        $translateru['Newest First']='Сначала новые';
        $translateru['Oldest First']='Сначала старые';
        $translateru['Create group']='Создать группу';
        $translateru['Template library']='Библиотека шаблонов';

        $translateru['Docs']='Документация';
        $translateru['Support']='Поддержка';
        $translateru['Newsletter']='Новости';
        $translateru['Create slide']='Создать слайд';
        $translateru['Slide Library']='Библиотека слайдов';
        $translateru['Text Bar']='Текстовый блок';
        $translateru['HTML']='HTML';
        $translateru['List the slides separated by commas on which you want the controls to be hidden.']='Список слайдов разделенный запятыми, на которых вы хотите скрыть контролы';
        $translateru['px']='px';
        $translateru['Developer']='Разработчику';
        $translateru['Loading']='Загрузка';
        $translateru['Add to group']='Добавить в группу';
        $translateru['Slide background image fill']='Фоновая картинка для заполнения слайда';
        $translateru["If the size of your image is not the same as your slide's, you can improve the result with the filling modes."]='Если размер вашего изображения отличается от размера слайда вы можете улучшить результат применив различные режимы заполнения';
        $translateru['Fill']='Заполнить';
        $translateru['Fit']='По ширине';
        $translateru['Stretch']='Растянуть';
        $translateru['Tile']='Плитка';
        $translateru['Maximum width, where the slides are visible.']='Максимальная ширина при которой слайды видимы';
        $translateru['Minimum slide distance']='Минимальная дистанция для слайда';
        $translateru['Slider background image']='Фоновая картинка слайдера';
        $translateru['Main animation']='Основная анимация';
        $translateru['This animation moves the slides.']='Эта анимация двигает слайды';
        $translateru['No animation']='Без анимации';
        $translateru['Main animation properties']='Свойства основной анимации';
        $translateru['ms']='мс';
        $translateru["If you turn off this option, you can't switch to the first slide from the last one."]='Если вы включите эту опцию, то вы не сможете перейти с первому слайду с последнего';
        $translateru['It switches one slide instead of moving all the visible slides.']='Это переключает один слайд, а не все видимые слайды';
        $translateru['Dynamic slider height']='Высота динамического слайдера';
        $translateru['Desktop landscape slider size']='Размер слайдера на десктопе';
        $translateru['Slider size becomes portrait slider size. It is recommended for fullpage responsive mode.']='Размер слайдера становится равным размеру слайду при портрете. Рекомендуется для полноэкранного режима';
        $translateru['loops']='цикл';
        $translateru['slide count']='счетчик слайда';
        $translateru['slide index']='индекс слайда';
        $translateru['last slide']='последний слайд';
        $translateru['next slide']='следующий слайд';
        $translateru['Use the Finish autoplay on option for this setting.']='Используйте финишное автопроизведение для этой настройки';
        $translateru['Click']='Клик';
        $translateru['Off']='Off';
        $translateru['Enter']='Нажатие';
        $translateru['Leave']='Leave';
        $translateru['Play on']='Play on';
        $translateru['3D']='3D';
        $translateru['Delayed loading']='Задержка загрузки';
        $translateru['Lazy loading']='Ленивая загрузка';
        $translateru['Optimize images']='Оптимизировать изображения';
        $translateru['Background image']='Фоновая картинка';
        $translateru['Switch on the Optimize images option for this setting.']='Включите оптимизирование изображений для этой настройки';
        $translateru['Slide background images']='Фоновая картинка для слайда';
        $translateru['Custom loading animation image']='Кастомная картинка для анимации загрузки';
        $translateru['Hide until complete load']='Прятать до полной загрузки';
        $translateru['The current slider will not start loading until the set slider is loaded completely.']='Текущий слайд не начнет загружаться пока установленный слайдер не загрузится полностью';
        $translateru['Cache support']='Поддержка кэша';
        $translateru['Only slide name']='Только имя слайда';
        $translateru['Slide name and description']='Имя и описание слайда';
        $translateru['Clear both before slider']='Clear both перед слайдом';
        $translateru["If your slider doesn't resize correctly, turn this option on."]='Если ваш слайдер не ресайзится корректно, отметьте эту опцию';
        $translateru['Background parallax']='Фоновый параллакс';
        $translateru['Editor - additional CSS files']='Редактирование дополнительных CSS файлов';
        $translateru['Real device detection']='Определение устройства пользователя';
        $translateru['Combined']='Комбинированный способ';
        $translateru['Circle counter']='Круглый счетчик';
        $translateru['Circle counter label']='Метка круглого счетчика';
        $translateru['Counter']='Счетчик';
        $translateru['Counter label']='Метка счетчика';
        $translateru['Image box']='Блок с картинкой';
        $translateru['Progress bar']='Progress bar';
        $translateru['Progress bar label']='Метка для progress bar';
        $translateru['Add animation']='Добавить анимацию';
        $translateru['Animation chain']='Цепочка анимаций';
        $translateru['Col']='Колонка';
        $translateru['Content']='Контент';
        $translateru['Dark Mode']='Ночной режим';
        $translateru['Delete layer']='Удалить слой';
        $translateru['Design']='Дизайн';
        $translateru['Duplicate layer']='Клонировать слой';
        $translateru['Load design']='Загрузить дизайн';
        $translateru['Lock Guides']='Заблокировать гайды';
        $translateru['More']='Еще';
        $translateru['NOTE: Layer design changes apply to each device. Watch video tutorial to learn responsive tools.']='ПРИМЕЧАНИЕ. Изменения дизайна слоя применяются к каждому устройству.';
        $translateru['Overwrite preset']='Перезаписать пресет';
        $translateru['Pick the align point of the child layer!']='Выберите точку выравнивания дочернего слоя!';
        $translateru['Pick the align point of the parent layer!']='Выберите точку выравнивания родительского слоя!';
        $translateru['Pick the child layer!']='Выберите дочерний слой!';
        $translateru['Pick the parent layer!']='Выберите родительский слой!';
        $translateru['Reset design to default']='Сбросить настройки дизайна на дефолт';
        $translateru['Row']='Строка';
        $translateru['Ruler']='Линейка';
        $translateru['Save design as new preset']='Сохранить дизайн новым пресетом';
        $translateru['Show Guides']='Показать гайды';
        $translateru['Smart Snap']='Умная привязка';
        $translateru['There is not any layer available to be child of the selected layer!']='Не существует ни одного слоя, который мог бы быть дочерним элементом выбранного слоя!';
        $translateru['Previous slie']='Предыдущий слайд';
        $translateru['Add empty slide']='Добавить пустой слайд';
        $translateru['Group name']='Название группы';
        $translateru['Create Group']='Создать группу';
        $translateru['Advanced']='Продвинутый';
        $translateru['Name']='Название';
        $translateru['Description']='Описание';
        $translateru['Link']='Ссылка';
        $translateru['Target']='Цель';

        $translateru['Back to slider']='Вернуться к слайдеру';
        $translateru['NOTE: Layer design changes apply to each device. Watch <a href="%s" target="_blank">video tutorial</a> to learn responsive tools.']='ПРИМЕЧАНИЕ. Изменения дизайна слоя применяются к каждому устройству. Посмотрите видео-учебник, чтобы изучить гибкие инструменты.';
        $translateru['Video']='Видео';
        $translateru['Self']='Self';
        $translateru['Blank']='Пустой';


        $translateru['Duplicate slide']='Клонировать слайд';
        $translateru['Delete slide']='Удалить слайд';
        $translateru['Canvas']='Холст';
        $translateru['Responsive tricks']='Трюки для адаптивности';
        $translateru['Mobile and tablet devices do not allow to autoplay videos. The background image displays when the autoplay not allowed.']='Мобильные и планшетные устройства не позволяют автоматически запускать видео. Фоновое изображение отображается, когда автовоспроизведение не разрешено.';
        $translateru['MP4 video']='MP4 видео';
        $translateru['auto']='авто';
        $translateru['metadata']='метаданные';
        $translateru['Blur']='Затуманить (blur)';
        $translateru['Gradient']='Градиент';
        $translateru['Structure']='Структура';
        $translateru['Basic']='Простые';
        $translateru['Media']='Медиа';
        $translateru['Canvas settings']='Настройки холста';
        $translateru['Clear Guides']='Очистить руководства';
        $translateru['Content types']='Типы контента';
        $translateru['From database']='База данных';
        $translateru['Create Group']='Создать группу';
        $translateru['group']='Группа';
        $translateru['group name']='Имя группы';
        $translateru['Blank']='Пустой';
        $translateru['Blank']='Пустой';

        $translateru['Color end']='Конечный цвет';
        $translateru["Slider's default"]='Слайдер по умолчанию';
        $translateru['Super slow']='Очень медленно';
        $translateru['Slow']='Медленно';
        $translateru['Fast']='Быстро';
        $translateru['Super fast']='Очень быстро';
        $translateru['Super soft']='Очень нежно';
        $translateru['Soft']='Нежно';
        $translateru['Strong']='Сильно';
        $translateru['Super strong']='Очень сильно';
        $translateru['Copy']='Копировать';





        if (isset($translateru[$text])){
            $res = $translateru[$text];
        } else {
            $res = $text;
        }

    }

    if ($res==''){
        $res = $text;
//        print_r(''.$text.'<br />');
    }

    return $res;
}

function n2_e($text, $domain = 'nextend') {
    echo n2_($text, $domain);
}

function n2_n($single, $plural, $number, $domain = 'nextend') {
    $translations = n2_get_translations_for_domain($domain);
    return $translations->translate_plural($single, $plural, $number);
}

function n2_en($single, $plural, $number, $domain = 'nextend') {
    echo n2_n($single, $plural, $number, $domain);
}

function n2_x($text, $context, $domain = 'nextend') {
    $translations = n2_get_translations_for_domain($domain);
    return $translations->translate($text, $context);
}

function n2_ex($text, $context, $domain = 'nextend') {
    echo n2_x($text, $context, $domain);
}